#! /usr/bin/perl
# mldel.cgi : delete ML for PPML
# Copyright(C) 2001 by Yuh.N
# $Id: mldel.cgi,v 1.1 2001/02/02 08:54:07 yuh Exp $
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
umask(0077);
use CGI;

require "mllib.pl";


$PIDFILE = "$ML_SETTING_ROOT/mldel.pid";

$q = new CGI;
print $q->header(-expires=>now, -title=>'MLdel');
print $q->start_html(-bgcolor=>'#ffffff');
print "<form action=$ENV{'SCRIPT_NAME'} method=POST>\n";
print '<h1>᡼󥰥ꥹȺ</h1>',"\n";

if ($q->param('SUBMIT') eq 'Accept') {

    $ml = $q->param('MLname');
    $ml =~ y/A-Z/a-z/;

    $pass = $q->param('MLpass');
    $admin = $q->param('MLadmin');

    if ($ml eq "") {
	print "᡼󥰥ꥹ̾ϤƤޤ<br>\n";
	last;
    }

    if ($pass eq "") {
	print "ѥɤϤƤޤ<br>\n";
	last;
    }

    if ($admin eq "") {
	print "̾ϤƤޤ<br>\n";
	last;
    }

    #
    # read aliases
    #
    open(A, $ALIASES) || die $!;

    @lst = ();
    %ali = ();
    $prev = "";
    while (<A>) {
	next if (/^\#/);
	$line = $_;
	if (/^[\t: ]+(.*)/) {
	    $prev .= $1;
	}
	else {
	    ($key, @wk) = split(/[:, \t\r\n]+/, $prev);
	    push(@lst, $key);
	    $ali{$key} .= join(',', @wk);
	    $prev = $line;
	}
    }
    ($key, @wk) = split(/[:, \t\r\n]+/, $prev);
    push(@lst, $key);
    $ali{$key} .= join(',', @wk);
    close(A);

    if (! defined($ali{$ml})) {
	print "᡼󥰥ꥹ $ml Ϥޤ<br>\n";
	last;
    }

    $mlr = sprintf("%s-request", $ml);
    if ($ali{$mlr} ne $admin) {
	print "Authentication error.<br>\n";
	last;
    }

    if (! -f "$ML_SETTING_ROOT/$ml/admins.ph") {
	print "ML setting error.<br>\n";
	last;
    }

    require "$ML_SETTING_ROOT/$ml/admins.ph";

    if ($members{$admin} ne $pass) {
	print "authentication error.<br>\n";
	last;
    }

    #
    # update /etc/aliases
    #

    lock_on($PIDFILE);
    $tmpfile = "$ALIASES.$$";
    open(A, $ALIASES);
    open(T, ">>$tmpfile") || die $!;

    while (<A>) {
	print T "# " if (/^$ml\:/);
	print T "# " if (/^$mlr\:/);
	print T;
    }

    close(T);
    close(A);
    lock_off($PIDFILE);

    system("mv -f $tmpfile $ALIASES");

    print "᡼󥰥ꥹ $ml ޤ\n";

}
else {

print << "EOT";
<table>
<tr>
<td>᡼󥰥ꥹ̾</td>
<td><input type=text name=MLname></td>
</tr>
<tr>
<td>ԥ᡼륢ɥ쥹</td>
<td><input type=text name=MLadmin></td>
</tr>
<tr>
<td>ѥ</td>
<td><input type=password name=MLpass></td>
</tr>
</table>
EOT

    print "<input type=submit name=SUBMIT value=Accept>\n";
}

print "</form>\n";
print $q->end_html();
